<template>
  <b-modal
    id="inviteUserModal"
    :title="$t('page.members.inviteUserTitle')"
    :hide-footer="true"
  >
    <!-- Body Text - New Invitation -->
    <i18n-t
      v-if="candidateForInvitation && !candidateForInvitation.invited"
      scope="global"
      keypath="page.members.inviteUserText"
      tag="span"
    >
      <template #email>
        <b>{{ candidateForInvitation.email }}</b>
      </template>
      <template #role>
        <b>{{ getRoleNameFromId(candidateForInvitation.roleId) }}</b>
      </template>
      <template #projectName>
        <b>{{ projectName }}</b>
      </template>
    </i18n-t>

    <!-- Body Text - Existing Invitation -->
    <i18n-t
      v-else-if="candidateForInvitation && candidateForInvitation.invited"
      scope="global"
      keypath="page.members.existingEmailInvitation"
      tag="span"
    >
      <template #email>
        <b>{{ candidateForInvitation.email }}</b>
      </template>
    </i18n-t>

    <!-- Buttons -->
    <div class="mt-3">
      <!-- Invite -->
      <b-button
        class="inviteModalRightBtn"
        variant="primary"
        @click="inviteUser"
      >
        {{
          !candidateForInvitation.invited
            ? $t("page.members.inviteUser")
            : $t("page.members.reInviteUser")
        }}
      </b-button>

      <!-- Cancel -->
      <b-button
        class="inviteModalLeftBtn"
        variant="secondary"
        @click="inviteUserModal.hide()"
      >
        {{ $t("buttons.cancel") }}
      </b-button>
    </div>
  </b-modal>
</template>

<script lang="ts">
import { useModal } from "bootstrap-vue-next";

import type { RoleDto } from "@coscine/api-client/dist/types/Coscine.Api";
import type { ExtendedProjectInvitationDto } from "@/modules/project/types";

export default defineComponent({
  props: {
    candidateForInvitation: {
      required: true,
      type: Object as PropType<ExtendedProjectInvitationDto>,
    },
    projectName: {
      default: "",
      type: [String, null] as PropType<string | null>,
    },
    roles: {
      default: null,
      type: [Array, null] as PropType<RoleDto[] | null>,
    },
  },
  setup() {
    const inviteUserModal = useModal("inviteUserModal");

    return { inviteUserModal };
  },
  methods: {
    getRoleNameFromId(
      roleId: string | null | undefined,
    ): string | null | undefined {
      if (this.roles && roleId) {
        for (const role of this.roles) {
          if (role.id === roleId) {
            return role.displayName;
          }
        }
      } else {
        return null;
      }
    },
    inviteUser() {
      const text = this.$t("page.members.invitedUserText", {
        email: this.candidateForInvitation.email,
        role: this.candidateForInvitation.roleId
          ? this.getRoleNameFromId(this.candidateForInvitation.roleId)
          : "",
        projectName: this.projectName,
      }).toString();
      const errorText = this.$t("page.members.invitedUserError", {
        email: this.candidateForInvitation.email,
      }).toString();
      this.$emit(
        "storeNewInvitation",
        this.candidateForInvitation.projectId,
        this.candidateForInvitation,
        text,
        errorText,
      );
      this.inviteUserModal.hide();
    },
  },
});
</script>

<style scoped>
.leftActionBtn {
  margin: 0px 2px 0px 0px;
}
.leftActionBtn:hover,
.leftActionBtn:active,
.leftActionBtn:focus {
  background-color: #cc071e;
  border-color: #8e0515;
  color: #ffffff;
}
.rightActionBtn {
  margin: 0px 0px 0px 2px;
}
.inviteModalLeftBtn {
  float: right;
  margin-right: 0.5rem !important;
}
.inviteModalRightBtn {
  float: right;
}
</style>
